package tfg.subsumption;


import tfg.util.Side;
import lejos.navigation.SimpleNavigator;
import lejos.nxt.Button;
import lejos.nxt.ButtonListener;
import lejos.nxt.LCD;
import lejos.subsumption.Behavior;

/**
* Comportamento responsvel por dar uma volta de 180 graus, invertendo a direo do rob.
* <BR> <BR>
* ********************************************************************** <BR>
*	<b>UNIFRA - Centro Universitrio Franciscano</b> <BR>
*	Graduao em Sistemas de Informao <BR>
*	Trabalho Final de Graduao, 1 Sem/2009 <BR>
*	<b>Orientador:</b> Prof. MSc. Guilherme Dhein <BR>
*	<b>Orientando:</b> Douglas Pereira Pasqualin <BR>
*   <BR>
*	<b>COPYLEFT</b> (Todos os direitos de reproduo autorizados deste que
*	preservados <BR> o nome da instituio e dos autores). <BR>
* **********************************************************************
*  
* @author <a href="mailto:douglas.pasqualin@gmail.com">Douglas Pasqualin</a>
* @version 0.2
*/
public class HalfTurn implements Behavior, ButtonListener 
{
	SimpleNavigator robot;
	Side side;
	boolean pressed;
	
	/**
	 * Comportamento responsvel por dar uma volta de 180 graus, invertendo a direo do rob.
	 * Mtodo construtor, deve ser passado um <b>SimpleNavigator</b> j instanciado e configurado.
	 * @param navigator objeto do tipo <b>lejos.navigation.SimpleNavigator</b> 
	 */	
	public HalfTurn(SimpleNavigator navigator)
	{
		this.robot = navigator;
		pressed = false;
		Button.LEFT.addButtonListener(this);
		Button.RIGHT.addButtonListener(this);		
	}

	public void action() 
	{
		LCD.drawString("HalfTurn     ", 1, 2);
		robot.rotate((side == Side.LEFT) ? 180 : -180);
		pressed = false;		
	}

	public void suppress() 
	{
		/** No precisa de cdigo, pois quando terminar a rotao o rob j estar parado*/
	}

	public boolean takeControl() 
	{
		return pressed;
	}

	public void buttonPressed(Button b) 
	{
		if (b.getId() == Button.ID_LEFT)
		{
			side = Side.LEFT;
			pressed = true;
		}
		else if (b.getId() == Button.ID_RIGHT)
		{
			side = Side.RIGHT;
			pressed = true;
		} 		
	}
	
	public void buttonReleased(Button b) {}
}
